#include "common.h"
#include "functions.h"


  // REMOVE
  void parserPrint( s_node *list, int32 level );


//////////////////////////////////////////////////////////////////////////

// global
int32 next_function_id;
s_node *db_functions, *db_types;

// local

////////////////////////////////////////////////////////////////////////// PRIVATE


////////////////////////////////////////////////////////////////////////// GLOBAL


void dbLoad( ){
	FILE *fp;
	char id[50];
	s_string *line;
	int32 i;

	next_function_id = 0;
	db_functions = nodeCreate(T_LIST_OUTTER);
	db_types = nodeCreate(T_LIST_OUTTER);

	// open dictionary.asm
	if((fp = fopen(FILE_DICTIONARY, "r")) == NULL){
		printf("** Dictionary file not found, no functions can be used\n");
		return;
	}

	line = stringCreate(1000);

	while(!feof(fp)){
		fgets(line->data, 1000, fp);
		if(!strncmp(line->data, ";F", 2)){
			// ;F(id:int private:ustr kit:ustr name:cast (i1:cast ... iN:cast) desc:str)
			i = 2;
			nodeAppendToList(db_functions, parseList(line, &i));

			// get function ID
			fgets(id, 50, fp);
			*(id + strlen(id) - 2) = '\0'; // chop ":\n"
			next_function_id = atol(id) + 1;
		} else if(!strncmp(line->data, ";T", 2)){
			// ;T(private:ustr kit:ustr name:cast (p1:cast .. pN:cast) desc:str)
			i = 2;
			nodeAppendToList(db_types, parseList(line, &i));

  // ???

		}
	}

	// close dictionary.asm
	fclose(fp);
	stringFree(line);

  printf("----------------------- functions found in dictionary\n");
  parserPrint(db_functions, 0);
}


s_node *dbFindFunction( s_string *name, s_node *last ){
	s_node *node, *func;

	if(last == NULL) func = (s_node *)db_functions->node;
	else func = last->next;

	while(func != NULL){
		// find function name
		node = (s_node *)func->node;
		while(node != NULL && node->type != T_CAST)
			node = node->next;
		if(node == NULL) return(NULL);

		// compare names
		if(stringCompare(((s_cast *)node->node)->name, name))
			return(func);
		func = func->next;
	}
	return(NULL);
}


s_node *dbGetInterface( s_node *func ){
	s_node *node;

	if(func != NULL){
		node = (s_node *)func->node;
		while(node != NULL && node->type != T_LIST_CODE)
			node = node->next;
		return(node);
	}
	return(NULL);
}


s_type *dbGetReturnType( s_node *func ){
	s_node *node;
	s_cast *cast;

	if(func != NULL){
		node = (s_node *)func->node;
		while(node != NULL && node->type != T_CAST)
			node = node->next;
		if(node == NULL) return(NULL);
		cast = (s_cast *)node->node;
		return(typeCreate(cast->mods.all, cast->type->data));
	}
	return(NULL);
}


int32 dbCompareInterfaces( s_node *parameters, s_node *interface ){
	while(parameters != NULL && interface != NULL){
		if(parameters->eval_type->mods.all != ((s_cast *)interface->node)->mods.all)
			return(0);
		if(!stringCompare(parameters->eval_type->type, ((s_cast *)interface->node)->type))
			return(0);
		parameters = parameters->next;
		interface = interface->next;
	}
	if(parameters == NULL && interface == NULL)
		return(1);
	return(0);
}


int32 dbCompareRawInterfaces( s_node *i1, s_node *i2 ){
	while(i1 != NULL && i2 != NULL){
		if(((s_cast *)i1->node)->mods.all != ((s_cast *)i2->node)->mods.all)
			return(0);
		if(!stringCompare(((s_cast *)i1->node)->type, ((s_cast *)i2->node)->type))
			return(0);
		i1 = i1->next;
		i2 = i2->next;
	}
	if(i1 == NULL && i2 == NULL)
		return(1);
	return(0);
}
