//
// main.c
//


//
// parse.c   
//

s_node *	parseList	( s_string *source, uint32 *i );
s_node *        parseSource	( s_string *source );


//
// type.c
//

s_type *	typeCreate	( uint32 mods, char *typename );


//
// node.c
//

s_node *        nodeCreate		( e_node_type type );
void		nodeAppendToList	( s_node *list, s_node *item );
s_type *	nodeEvaluate		( s_node *node );
s_type *	nodeEvaluateList	( s_node *list );


//
// string.c
//

s_string *	stringCreate		( uint32 size );
void		stringFree		( s_string *s );
s_string *	stringToLower		( s_string *s );
char		stringSkipWhite		( s_string *s, uint32 *index );
char		stringFindWhite		( s_string *s, uint32 *index );
char		stringExpect		( s_string *s, uint32 *index, char e );
char		stringFindChar		( s_string *s, uint32 *index, char m );
s_string *	stringCloneRange	( s_string *s, uint32 start, uint32 end );
int32		stringCompare		( s_string *s1, s_string *s2 );
int32		stringCompareData	( char *s1, char *s2 );


//
// number.c
//

s_num *		stringToNumber	( s_string *s );


//
// cast.c
//

s_cast *	castCreate	( s_string *s );
void		castFree	( s_cast *cast );
uint32		castDisplay	( char *out, s_node *node );


//
// db.c
//

void		dbLoad			( );
s_node *	dbFindFunction		( s_string *name, s_node *last );
s_node *	dbGetInterface		( s_node *func );
s_type *	dbGetReturnType		( s_node *func );
int32		dbCompareInterfaces	( s_node *parameters, s_node *interface );
int32		dbCompareRawInterfaces	( s_node *i1, s_node *i2 );


//
// output.c
//

void	outputAsm	( char *code, ... );
void	outputInterface	( char *code );
void	outputOpen	( );
void	outputFlush	( );


//
// x.c
//

int32	callMacro	( s_string *name, s_node *p1, s_node *list );
int64	callFunction	( s_string *name, s_node *p1, s_node *list );


//
// var.c
//

s_var *		varCreate		( s_cast *var );
void		varFreeAll		( );
s_var *		varFind			( s_string *name );
void		varUsageWarnings	( );

