#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global
s_type *void_type;

// local

//////////////////////////////////////////////////////////////////////////


int main( int argc, char *argv[] ){
	FILE *fp;
	char *filename;
	struct stat stat_buffer;
	uint32 a;
	s_string *source;
	s_node *source_list;


	// test command line arguments
	if(argc != 2){
		printf("ERROR: No source file specified.\n");
		exit(1);
	}
	filename = argv[1];
	if(!stringCompareData(&argv[1][strlen(argv[1])-3], ".cr")){
		printf("ERROR: Source file needs the .cr extension.\n");
		exit(1);
	}


	// copy source file to array
	if((fp = fopen(filename, "r")) == NULL){
		printf("ERROR: Unable to open source file.\n");
		exit(1);
	}
	stat((const char *)filename, &stat_buffer);
	if((source = stringCreate(stat_buffer.st_size)) == NULL){
		printf("ERROR: can't create string for source code\n");
		exit(1);
	}
	a = 0;
	while(!feof(fp)){
		source->data[a] = getc(fp);
		a++;
	}
	source->data[a-1] = '\0';
	fclose(fp);
	filename[strlen(filename)-3] = '\0';


	// load type and function interfaces from dictionary.asm
	dbLoad();


	// open dictionary.asm file for writing
	outputOpen();


	// create void type
	void_type = typeCreate(0, "void");


	// parse code from text to tokenized list
	// compile tokenized list into assembler code
	source_list = parseSource(source)->node;
	if(source_list != NULL){

  printf("----------------------- assembler output\n");
		while(source_list != NULL){
			if(nodeEvaluateList(source_list) == 0){
				printf("-- ABORT --\n");
				exit(1);
			}
			source_list = source_list->next;
		}
  printf("----------------------- finished\n");

	} else {
		printf("ERROR: empty file\n");
	}


	exit(0);
}
