#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global

// local

////////////////////////////////////////////////////////////////////////// PRIVATE


s_num *stringToDecimal( s_num *n, s_string *s ){
	uint64 number, old;
	int32 end, x;
	char a, *data;

	data = s->data;
	number = 0;
	x = 1;
	end = s->size - 1;
	while(end >= 0){
		old = number;
		a = data[end];
		if(a<'0' || a>'9'){
			n->type = NUMBER_INVALID;
			return(n);
		}
		number += (a - '0')*x;
		end--;
		x *= 10;
		if(old > number){
			n->type = NUMBER_TOO_BIG;
			return(n);
		}
	}
	n->type = NUMBER_OK;
	n->value = number;
	return(n);
}


s_num *stringToBinary( s_num *n, s_string *s ){
	uint64 number;
	int32 end, x;
	char a, *data;

	data = s->data;
	number = 0;
	x = 0;
	end = s->size - 2;
	if(end > 63){					// 64 digits
		n->type = NUMBER_TOO_BIG;
		return(n);
	}
	while(end >= 0){
		a = data[end];
		if(a<'0' || a>'1'){
			n->type = NUMBER_INVALID;
			return(n);
		}
		number += (a - '0')<<x;
		end--;
		x++;
	}
	n->type = NUMBER_OK;
	n->value = number;
	return(n);
}


s_num *stringToHex( s_num *n, s_string *s ){
	uint64 number;
	int32 end, x;
	char a, *data;

	data = s->data;
	number = 0;
	x = 0;
	end = s->size - 1;
	if(end > 15){					// 16 digits
		n->type = NUMBER_TOO_BIG;
		return(n);
	}
	if((data[end] | 32) == 'h') end--;
	while(end >= 0){
		a = data[end];
		if(end == 1) if((data[1] | 32) == 'x'){
			n->type = NUMBER_OK;
			n->value = number;
			return(n);
		}
		if(a>'9') a |= 32;
		if(a<'0' || (a>'9' && a<'a') || a>'f'){
			n->type = NUMBER_INVALID;
			return(n);
		}
		if(a<='9') number += (a - '0')<<x;
		else number += (a - 'a' + 10)<<x;
		end--;
		x += 4;
	}
	n->type = NUMBER_OK;
	n->value = number;
	return(n);
}


s_num *stringToOctal( s_num *n, s_string *s ){
	uint64 number;
	int32 end, x;
	char a, *data;

	data = s->data;
	number = 0;
	x = 0;
	end = s->size - 1;
	if(end > 21){					// 21.33 digits
		n->type = NUMBER_TOO_BIG;
		return(n);
	}
	if(end > 20 && data[1] > '1'){
		n->type = NUMBER_TOO_BIG;
		return(n);
	}
	while(end > 0){
		a = data[end];
		if(a<'0' || a>'7'){
			n->type = NUMBER_INVALID;
			return(n);
		}
		number += (a - '0')<<x;
		end--;
		x += 3;
	}
	n->type = NUMBER_OK;
	n->value = number;
	return(n);
}


//s_float stringToFloat( s_string *s ){
//	return(0);
//}


////////////////////////////////////////////////////////////////////////// GLOBAL


s_num *stringToNumber( s_string *s ){
	uint32 end;
	char *data;
	s_num *n;

	data = s->data;
	n = (s_num *)malloc(sizeof(s_num));
	if(n == NULL){
		printf("ERROR: malloc error in stringToNumber()\n");
		return(NULL);
	}

	if(data[0] < '0' || data[0] > '9'){
		n->type = NOT_A_NUMBER;
		return(n);
	}

	end = s->size - 1;
	if(data[0] == '0'){
		if((data[1] | 32) == 'x') return(stringToHex(n, s));
		if((data[end] | 32) == 'h') return(stringToHex(n, s));
		if((data[end] | 32) == 'b') return(stringToBinary(n, s));
		return(stringToOctal(n, s));
	}
	if((data[end] | 32) == 'h') return(stringToHex(n, s));
	if((data[end] | 32) == 'b') return(stringToBinary(n, s));
//	if( hasDot || 'e' || 'E') return(stringToFloat(n, s));
//	'E' should also be allowed in decimal integers if its small enough
//	a float will only be used if E is too large or if it contains a fractional part
	return(stringToDecimal(n, s));
}
