#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global

// local
FILE *dictfile, *tempfile;
char *interface;

////////////////////////////////////////////////////////////////////////// PRIVATE


////////////////////////////////////////////////////////////////////////// GLOBAL


void outputAsm( char *code, ... ){
	char buffer[1000];
	va_list ap;

	va_start(ap, code);
	vsnprintf(buffer, 1000, code, ap);
	fwrite("\t", 1, 1, tempfile);
	fwrite(buffer, 1, strlen(buffer), tempfile);
  printf("  : %s", buffer);
}


void outputInterface( char *code ){
	char n[20];

	sprintf(n, "f%d:\n", next_function_id);

	if(interface != NULL) free(interface);
	interface = (char *)malloc(strlen(code) + strlen(n) + 2);
	if(interface == NULL){
		printf("ERROR: malloc error in outputInterface()\n");
		exit(1);
	}
	sprintf(interface, "\n%s%s", code, n);

  printf("  : %s", code);
  printf("  : %s", n);

	if((tempfile = fopen(FILE_TEMP, "w+")) == NULL){
		printf("ERROR: Unable to open temp file for reading and writing\n");
		exit(1);
	}
}

 
void outputOpen( ){
	struct stat stat_buffer;
	char header[] = {"[section .text]\n[bits 32]\n[org 0xF0000000]\n"};

	if((dictfile = fopen(FILE_DICTIONARY, "a")) == NULL){
		printf("ERROR: Unable to open dictionary file for writing\n");
		exit(1);
	}

	stat((const char *)FILE_DICTIONARY, &stat_buffer);
	if(stat_buffer.st_size == 0){
  printf("----------------------- building new dictionary\n");
		printf("** Creating dictionary.asm\n");
		fwrite(header, 1, strlen(header), dictfile);
	}

	interface = NULL;
}


void outputFlush( ){
	char buffer[50], c;

	// copy interface to dictionary.asm
	fwrite(interface, 1, strlen(interface), dictfile);

	// setup stack for function's local variables
	if(vars_stack_offset)
		sprintf(buffer, "\tpush ebp\n\tmov ebp,esp\n\tsub esp, %d\n", vars_stack_offset);
	else
		sprintf(buffer, "\tpush ebp\n\tmov ebp,esp\n");
	fwrite(buffer, 1, strlen(buffer), dictfile);

	// copy temp file file to dictionary.asm
	fseek(tempfile, 0, SEEK_SET);
	while(!feof(tempfile)){
		c = fgetc(tempfile);
		if(!feof(tempfile)) fputc(c, dictfile);
	}
	fclose(tempfile);
	unlink(FILE_TEMP);

	printf("** Added function to dictionary\n");
}
